/* aboutdialog.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/aboutdialog.h>
#include <config.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gdk-pixbuf/gdk-pixdata.h>




enum  {
	VALIDE_ABOUT_DIALOG_DUMMY_PROPERTY
};
static GObject * valide_about_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer valide_about_dialog_parent_class = NULL;

static const char* VALIDE_ABOUT_DIALOG_authors_[] = {"Nicolas Joseph <gege2061@redaction-developpez.com>", NULL};
static const char* VALIDE_ABOUT_DIALOG_copyright_ = "Copyright \xc2\xa9 2008 Nicolas Joseph";
static const char* VALIDE_ABOUT_DIALOG_program_name_ = "Valide";
static const char* VALIDE_ABOUT_DIALOG_version_ = PACKAGE_VERSION;
static const char* VALIDE_ABOUT_DIALOG_website_ = "http://home.gna.org/valide/";


#line 23 "aboutdialog.vala"
ValideAboutDialog* valide_about_dialog_new (void) {
	ValideAboutDialog * self;
	self = g_object_newv (VALIDE_TYPE_ABOUT_DIALOG, 0, NULL);
	return self;
}


static GObject * valide_about_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideAboutDialogClass * klass;
	GObjectClass * parent_class;
	ValideAboutDialog * self;
	GError * inner_error;
	klass = VALIDE_ABOUT_DIALOG_CLASS (g_type_class_peek (VALIDE_TYPE_ABOUT_DIALOG));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_ABOUT_DIALOG (obj);
	inner_error = NULL;
	{
		char* contents;
		contents = NULL;
		{
			gboolean _tmp2;
			char* _tmp1;
			char* _tmp0;
			_tmp1 = NULL;
#line 40 "aboutdialog.vala"
			_tmp0 = NULL;
#line 40 "aboutdialog.vala"
			_tmp2 = g_file_get_contents ((_tmp0 = g_build_filename (PACKAGE_DATA_DIR, "COPYING", NULL)), &_tmp1, NULL, &inner_error);
#line 40 "aboutdialog.vala"
			(contents = (g_free (contents), NULL));
#line 40 "aboutdialog.vala"
			contents = _tmp1;
#line 40 "aboutdialog.vala"
			_tmp2;
			if (inner_error != NULL) {
				goto __catch0_g_error;
			}
			_tmp0 = (g_free (_tmp0), NULL);
#line 42 "aboutdialog.vala"
			gtk_about_dialog_set_license (GTK_ABOUT_DIALOG (self), contents);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError * e;
			e = inner_error;
			inner_error = NULL;
			{
			}
		}
		__finally0:
		;
		{
			char* _tmp3;
			GdkPixbuf* _tmp4;
			GdkPixbuf* pixbuf;
#line 49 "aboutdialog.vala"
			_tmp3 = NULL;
#line 49 "aboutdialog.vala"
			_tmp4 = NULL;
			pixbuf = (_tmp4 = gdk_pixbuf_new_from_file ((_tmp3 = g_build_filename (PACKAGE_PIXMAPS_DIR, "logo.png", NULL)), &inner_error), (_tmp3 = (g_free (_tmp3), NULL)), _tmp4);
			if (inner_error != NULL) {
				goto __catch1_g_error;
			}
#line 50 "aboutdialog.vala"
			gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG (self), pixbuf);
			(pixbuf == NULL ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL)));
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError * e;
			e = inner_error;
			inner_error = NULL;
			{
			}
		}
		__finally1:
		;
#line 55 "aboutdialog.vala"
		gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (self), VALIDE_ABOUT_DIALOG_authors_);
#line 56 "aboutdialog.vala"
		gtk_about_dialog_set_program_name (GTK_ABOUT_DIALOG (self), VALIDE_ABOUT_DIALOG_program_name_);
#line 57 "aboutdialog.vala"
		gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (self), VALIDE_ABOUT_DIALOG_version_);
#line 58 "aboutdialog.vala"
		gtk_about_dialog_set_website (GTK_ABOUT_DIALOG (self), VALIDE_ABOUT_DIALOG_website_);
#line 59 "aboutdialog.vala"
		gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG (self), VALIDE_ABOUT_DIALOG_copyright_);
		contents = (g_free (contents), NULL);
	}
	return obj;
}


static void valide_about_dialog_class_init (ValideAboutDialogClass * klass) {
	valide_about_dialog_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = valide_about_dialog_constructor;
}


static void valide_about_dialog_init (ValideAboutDialog * self) {
}


GType valide_about_dialog_get_type (void) {
	static GType valide_about_dialog_type_id = 0;
	if (G_UNLIKELY (valide_about_dialog_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideAboutDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_about_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideAboutDialog), 0, (GInstanceInitFunc) valide_about_dialog_init };
		valide_about_dialog_type_id = g_type_register_static (GTK_TYPE_ABOUT_DIALOG, "ValideAboutDialog", &g_define_type_info, 0);
	}
	return valide_about_dialog_type_id;
}




