/* aboutdialog.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.AboutDialog : Gtk.AboutDialog
{
  private const string[] authors_ = {
    "Nicolas Joseph <gege2061@redaction-developpez.com>",
    null
  };
  private const string copyright_ = "Copyright \xc2\xa9 2008 Nicolas Joseph";
  private const string program_name_ = "Valide";
  private const string version_ = Config.PACKAGE_VERSION;
  private const string website_ = "http://home.gna.org/valide/";

  construct
  {
    string contents;

    try
    {
      GLib.FileUtils.get_contents (GLib.Path.build_filename (Config.PACKAGE_DATA_DIR, "COPYING"),
                                   out contents);
      this.license = contents;
    }
    catch (GLib.Error e)
    {
    }
    try
    {
      var pixbuf = new Gdk.Pixbuf.from_file (GLib.Path.build_filename (Config.PACKAGE_PIXMAPS_DIR, "logo.png"));
      this.logo = pixbuf;
    }
    catch (GLib.Error e)
    {
    }
    this.authors = this.authors_;
    this.program_name = this.program_name_;
    this.version = this.version_;
    this.website = this.website_;
    this.copyright = this.copyright_;
  }
}

