/* compiler.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/compiler.h>
#include <glib/gi18n-lib.h>




enum  {
	VALIDE_COMPILER_DUMMY_PROPERTY,
	VALIDE_COMPILER_WORKING_DIRECTORY,
	VALIDE_COMPILER_START_MSG,
	VALIDE_COMPILER_END_MSG,
	VALIDE_COMPILER_EXECUTABLE
};
static void valide_compiler_real_parsing (ValideAbstractExecutable* base, ValideExecutableManager* sender, char** line);
static gpointer valide_compiler_parent_class = NULL;



#line 51 "compiler.vala"
static void valide_compiler_real_parsing (ValideAbstractExecutable* base, ValideExecutableManager* sender, char** line) {
	ValideCompiler * self;
	self = VALIDE_COMPILER (base);
#line 51 "compiler.vala"
	g_return_if_fail (VALIDE_IS_EXECUTABLE_MANAGER (sender));
#line 51 "compiler.vala"
	g_return_if_fail (line != NULL);
#line 53 "compiler.vala"
	if (g_str_has_prefix ((*line), "Compilation failed")) {
		char* _tmp1;
		char* _tmp0;
		_tmp1 = NULL;
		_tmp0 = NULL;
#line 55 "compiler.vala"
		(*line) = (_tmp1 = g_strconcat ((_tmp0 = g_strconcat ("<span foreground=\"#FF0000\">", (*line), NULL)), "</span>", NULL), ((*line) = (g_free ((*line)), NULL)), _tmp1);
		_tmp0 = (g_free (_tmp0), NULL);
	} else {
#line 57 "compiler.vala"
		if (strstr ((*line), "error:") != NULL) {
			char* _tmp3;
			char* _tmp2;
			_tmp3 = NULL;
			_tmp2 = NULL;
#line 59 "compiler.vala"
			(*line) = (_tmp3 = g_strconcat ((_tmp2 = g_strconcat ("<span foreground=\"#FF0000\">", (*line), NULL)), "</span>", NULL), ((*line) = (g_free ((*line)), NULL)), _tmp3);
			_tmp2 = (g_free (_tmp2), NULL);
		}
	}
#line 61 "compiler.vala"
	if (g_str_has_prefix ((*line), "Compilation succeeded")) {
		char* _tmp5;
		char* _tmp4;
		_tmp5 = NULL;
		_tmp4 = NULL;
#line 63 "compiler.vala"
		(*line) = (_tmp5 = g_strconcat ((_tmp4 = g_strconcat ("<span foreground=\"#ED7F10\">", (*line), NULL)), "</span>", NULL), ((*line) = (g_free ((*line)), NULL)), _tmp5);
		_tmp4 = (g_free (_tmp4), NULL);
	} else {
#line 65 "compiler.vala"
		if (strstr ((*line), "warning:") != NULL) {
			char* _tmp7;
			char* _tmp6;
			_tmp7 = NULL;
			_tmp6 = NULL;
#line 67 "compiler.vala"
			(*line) = (_tmp7 = g_strconcat ((_tmp6 = g_strconcat ("<span foreground=\"#ED7F10\">", (*line), NULL)), "</span>", NULL), ((*line) = (g_free ((*line)), NULL)), _tmp7);
			_tmp6 = (g_free (_tmp6), NULL);
		}
	}
}


#line 25 "compiler.vala"
ValideCompiler* valide_compiler_new (void) {
	ValideCompiler * self;
	self = g_object_newv (VALIDE_TYPE_COMPILER, 0, NULL);
	return self;
}


char* valide_compiler_get_working_directory (ValideCompiler* self) {
	g_return_val_if_fail (VALIDE_IS_COMPILER (self), NULL);
#line 29 "compiler.vala"
	return NULL;
}


void valide_compiler_set_working_directory (ValideCompiler* self, char* value) {
	g_return_if_fail (VALIDE_IS_COMPILER (self));
}


char* valide_compiler_get_start_msg (ValideCompiler* self) {
	const char* _tmp0;
	g_return_val_if_fail (VALIDE_IS_COMPILER (self), NULL);
#line 35 "compiler.vala"
	_tmp0 = NULL;
#line 35 "compiler.vala"
	return (_tmp0 = _ ("<b>Compiling start</b>\n<i>{$cmd}</i>"), (_tmp0 == NULL ? NULL : g_strdup (_tmp0)));
}


void valide_compiler_set_start_msg (ValideCompiler* self, char* value) {
	g_return_if_fail (VALIDE_IS_COMPILER (self));
}


char* valide_compiler_get_end_msg (ValideCompiler* self) {
	const char* _tmp0;
	g_return_val_if_fail (VALIDE_IS_COMPILER (self), NULL);
#line 41 "compiler.vala"
	_tmp0 = NULL;
#line 41 "compiler.vala"
	return (_tmp0 = _ ("<b>Compiling end</b>"), (_tmp0 == NULL ? NULL : g_strdup (_tmp0)));
}


void valide_compiler_set_end_msg (ValideCompiler* self, char* value) {
	g_return_if_fail (VALIDE_IS_COMPILER (self));
}


char* valide_compiler_get_executable (ValideCompiler* self) {
	g_return_val_if_fail (VALIDE_IS_COMPILER (self), NULL);
#line 47 "compiler.vala"
	return g_strdup ("valac");
}


void valide_compiler_set_executable (ValideCompiler* self, char* value) {
	g_return_if_fail (VALIDE_IS_COMPILER (self));
}


static void valide_compiler_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideCompiler * self;
	self = VALIDE_COMPILER (object);
	switch (property_id) {
		case VALIDE_COMPILER_WORKING_DIRECTORY:
		g_value_set_string (value, valide_compiler_get_working_directory (self));
		break;
		case VALIDE_COMPILER_START_MSG:
		g_value_set_string (value, valide_compiler_get_start_msg (self));
		break;
		case VALIDE_COMPILER_END_MSG:
		g_value_set_string (value, valide_compiler_get_end_msg (self));
		break;
		case VALIDE_COMPILER_EXECUTABLE:
		g_value_set_string (value, valide_compiler_get_executable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_compiler_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideCompiler * self;
	self = VALIDE_COMPILER (object);
	switch (property_id) {
		case VALIDE_COMPILER_WORKING_DIRECTORY:
		valide_compiler_set_working_directory (self, g_value_get_string (value));
		break;
		case VALIDE_COMPILER_START_MSG:
		valide_compiler_set_start_msg (self, g_value_get_string (value));
		break;
		case VALIDE_COMPILER_END_MSG:
		valide_compiler_set_end_msg (self, g_value_get_string (value));
		break;
		case VALIDE_COMPILER_EXECUTABLE:
		valide_compiler_set_executable (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_compiler_class_init (ValideCompilerClass * klass) {
	valide_compiler_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = valide_compiler_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_compiler_set_property;
	VALIDE_ABSTRACT_EXECUTABLE_CLASS (klass)->parsing = valide_compiler_real_parsing;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_COMPILER_WORKING_DIRECTORY, g_param_spec_string ("working-directory", "working-directory", "working-directory", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_COMPILER_START_MSG, g_param_spec_string ("start-msg", "start-msg", "start-msg", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_COMPILER_END_MSG, g_param_spec_string ("end-msg", "end-msg", "end-msg", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_COMPILER_EXECUTABLE, g_param_spec_string ("executable", "executable", "executable", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void valide_compiler_init (ValideCompiler * self) {
}


GType valide_compiler_get_type (void) {
	static GType valide_compiler_type_id = 0;
	if (G_UNLIKELY (valide_compiler_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideCompilerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_compiler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideCompiler), 0, (GInstanceInitFunc) valide_compiler_init };
		valide_compiler_type_id = g_type_register_static (VALIDE_TYPE_ABSTRACT_EXECUTABLE, "ValideCompiler", &g_define_type_info, 0);
	}
	return valide_compiler_type_id;
}




