/* compiler.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_COMPILER_H__
#define __SRC_COMPILER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "src/third-party/abstract-executable.h"
#include "src/third-party/executable-manager.h"

G_BEGIN_DECLS


#define VALIDE_TYPE_COMPILER (valide_compiler_get_type ())
#define VALIDE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_COMPILER, ValideCompiler))
#define VALIDE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_COMPILER, ValideCompilerClass))
#define VALIDE_IS_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_COMPILER))
#define VALIDE_IS_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_COMPILER))
#define VALIDE_COMPILER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_COMPILER, ValideCompilerClass))

typedef struct _ValideCompiler ValideCompiler;
typedef struct _ValideCompilerClass ValideCompilerClass;
typedef struct _ValideCompilerPrivate ValideCompilerPrivate;

struct _ValideCompiler {
	ValideAbstractExecutable parent_instance;
	ValideCompilerPrivate * priv;
};

struct _ValideCompilerClass {
	ValideAbstractExecutableClass parent_class;
};


ValideCompiler* valide_compiler_new (void);
char* valide_compiler_get_working_directory (ValideCompiler* self);
void valide_compiler_set_working_directory (ValideCompiler* self, char* value);
char* valide_compiler_get_start_msg (ValideCompiler* self);
void valide_compiler_set_start_msg (ValideCompiler* self, char* value);
char* valide_compiler_get_end_msg (ValideCompiler* self);
void valide_compiler_set_end_msg (ValideCompiler* self, char* value);
char* valide_compiler_get_executable (ValideCompiler* self);
void valide_compiler_set_executable (ValideCompiler* self, char* value);
GType valide_compiler_get_type (void);


G_END_DECLS

#endif
