/* executable.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/executable.h>
#include <glib/gi18n-lib.h>




struct _ValideExecutablePrivate {
	char* executable_;
};

#define VALIDE_EXECUTABLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_EXECUTABLE, ValideExecutablePrivate))
enum  {
	VALIDE_EXECUTABLE_DUMMY_PROPERTY,
	VALIDE_EXECUTABLE_WORKING_DIRECTORY,
	VALIDE_EXECUTABLE_START_MSG,
	VALIDE_EXECUTABLE_END_MSG,
	VALIDE_EXECUTABLE_EXECUTABLE
};
static gpointer valide_executable_parent_class = NULL;
static void valide_executable_dispose (GObject * obj);



#line 25 "executable.vala"
ValideExecutable* valide_executable_new (void) {
	ValideExecutable * self;
	self = g_object_newv (VALIDE_TYPE_EXECUTABLE, 0, NULL);
	return self;
}


char* valide_executable_get_working_directory (ValideExecutable* self) {
	g_return_val_if_fail (VALIDE_IS_EXECUTABLE (self), NULL);
#line 31 "executable.vala"
	return NULL;
}


void valide_executable_set_working_directory (ValideExecutable* self, char* value) {
	g_return_if_fail (VALIDE_IS_EXECUTABLE (self));
}


char* valide_executable_get_start_msg (ValideExecutable* self) {
	const char* _tmp0;
	g_return_val_if_fail (VALIDE_IS_EXECUTABLE (self), NULL);
#line 37 "executable.vala"
	_tmp0 = NULL;
#line 37 "executable.vala"
	return (_tmp0 = _ ("<b>Executable start</b>"), (_tmp0 == NULL ? NULL : g_strdup (_tmp0)));
}


void valide_executable_set_start_msg (ValideExecutable* self, char* value) {
	g_return_if_fail (VALIDE_IS_EXECUTABLE (self));
}


char* valide_executable_get_end_msg (ValideExecutable* self) {
	const char* _tmp0;
	g_return_val_if_fail (VALIDE_IS_EXECUTABLE (self), NULL);
#line 43 "executable.vala"
	_tmp0 = NULL;
#line 43 "executable.vala"
	return (_tmp0 = _ ("<b>Executable end</b>"), (_tmp0 == NULL ? NULL : g_strdup (_tmp0)));
}


void valide_executable_set_end_msg (ValideExecutable* self, char* value) {
	g_return_if_fail (VALIDE_IS_EXECUTABLE (self));
}


char* valide_executable_get_executable (ValideExecutable* self) {
	const char* _tmp0;
	g_return_val_if_fail (VALIDE_IS_EXECUTABLE (self), NULL);
#line 49 "executable.vala"
	_tmp0 = NULL;
#line 49 "executable.vala"
	return (_tmp0 = self->priv->executable_, (_tmp0 == NULL ? NULL : g_strdup (_tmp0)));
}


void valide_executable_set_executable (ValideExecutable* self, char* value) {
	char* _tmp3;
	const char* _tmp2;
	g_return_if_fail (VALIDE_IS_EXECUTABLE (self));
	_tmp3 = NULL;
#line 50 "executable.vala"
	_tmp2 = NULL;
#line 50 "executable.vala"
	self->priv->executable_ = (_tmp3 = (_tmp2 = value, (_tmp2 == NULL ? NULL : g_strdup (_tmp2))), (self->priv->executable_ = (g_free (self->priv->executable_), NULL)), _tmp3);
}


static void valide_executable_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideExecutable * self;
	self = VALIDE_EXECUTABLE (object);
	switch (property_id) {
		case VALIDE_EXECUTABLE_WORKING_DIRECTORY:
		g_value_set_string (value, valide_executable_get_working_directory (self));
		break;
		case VALIDE_EXECUTABLE_START_MSG:
		g_value_set_string (value, valide_executable_get_start_msg (self));
		break;
		case VALIDE_EXECUTABLE_END_MSG:
		g_value_set_string (value, valide_executable_get_end_msg (self));
		break;
		case VALIDE_EXECUTABLE_EXECUTABLE:
		g_value_set_string (value, valide_executable_get_executable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_executable_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideExecutable * self;
	self = VALIDE_EXECUTABLE (object);
	switch (property_id) {
		case VALIDE_EXECUTABLE_WORKING_DIRECTORY:
		valide_executable_set_working_directory (self, g_value_get_string (value));
		break;
		case VALIDE_EXECUTABLE_START_MSG:
		valide_executable_set_start_msg (self, g_value_get_string (value));
		break;
		case VALIDE_EXECUTABLE_END_MSG:
		valide_executable_set_end_msg (self, g_value_get_string (value));
		break;
		case VALIDE_EXECUTABLE_EXECUTABLE:
		valide_executable_set_executable (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_executable_class_init (ValideExecutableClass * klass) {
	valide_executable_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideExecutablePrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_executable_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_executable_set_property;
	G_OBJECT_CLASS (klass)->dispose = valide_executable_dispose;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_EXECUTABLE_WORKING_DIRECTORY, g_param_spec_string ("working-directory", "working-directory", "working-directory", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_EXECUTABLE_START_MSG, g_param_spec_string ("start-msg", "start-msg", "start-msg", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_EXECUTABLE_END_MSG, g_param_spec_string ("end-msg", "end-msg", "end-msg", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_EXECUTABLE_EXECUTABLE, g_param_spec_string ("executable", "executable", "executable", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void valide_executable_init (ValideExecutable * self) {
	self->priv = VALIDE_EXECUTABLE_GET_PRIVATE (self);
}


static void valide_executable_dispose (GObject * obj) {
	ValideExecutable * self;
	self = VALIDE_EXECUTABLE (obj);
	self->priv->executable_ = (g_free (self->priv->executable_), NULL);
	G_OBJECT_CLASS (valide_executable_parent_class)->dispose (obj);
}


GType valide_executable_get_type (void) {
	static GType valide_executable_type_id = 0;
	if (G_UNLIKELY (valide_executable_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideExecutableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_executable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideExecutable), 0, (GInstanceInitFunc) valide_executable_init };
		valide_executable_type_id = g_type_register_static (VALIDE_TYPE_ABSTRACT_EXECUTABLE, "ValideExecutable", &g_define_type_info, 0);
	}
	return valide_executable_type_id;
}




