/* main.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/main.h>
#include <libxml/parser.h>
#include <gtk/gtk.h>
#include "src/splashscreen.h"




enum  {
	VALIDE_MAIN_DUMMY_PROPERTY
};
static gboolean _valide_splash_screen_run_gsource_func (gpointer self);
static gpointer valide_main_parent_class = NULL;



#line 50 "splashscreen.vala"
static gboolean _valide_splash_screen_run_gsource_func (gpointer self) {
	return valide_splash_screen_run (self);
}


#line 25 "main.vala"
gint valide_main_main (char** args, int args_length1) {
	ValideSplashScreen* splash;
	gint _tmp0;
#line 27 "main.vala"
	xmlInitParser ();
#line 28 "main.vala"
	gtk_init (&args_length1, &args);
	splash = valide_splash_screen_get_instance ();
#line 30 "main.vala"
	g_idle_add (_valide_splash_screen_run_gsource_func, splash);
#line 31 "main.vala"
	gtk_main ();
#line 32 "main.vala"
	xmlCleanupParser ();
#line 33 "main.vala"
	return (_tmp0 = 0, (splash == NULL ? NULL : (splash = (g_object_unref (splash), NULL))), _tmp0);
}


#line 25 "main.vala"
int main (int argc, char ** argv) {
#line 25 "main.vala"
	g_type_init ();
#line 25 "main.vala"
	return valide_main_main (argv, argc);
}


#line 23 "main.vala"
ValideMain* valide_main_new (GType type) {
	ValideMain* self;
	self = ((ValideMain*) g_type_create_instance (type));
	return self;
}


static void valide_main_class_init (ValideMainClass * klass) {
	valide_main_parent_class = g_type_class_peek_parent (klass);
}


static void valide_main_init (ValideMain * self) {
	self->ref_count = 1;
}


GType valide_main_get_type (void) {
	static GType valide_main_type_id = 0;
	if (G_UNLIKELY (valide_main_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideMain), 0, (GInstanceInitFunc) valide_main_init };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		valide_main_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ValideMain", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return valide_main_type_id;
}


gpointer valide_main_ref (gpointer instance) {
	ValideMain* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void valide_main_unref (gpointer instance) {
	ValideMain* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		g_type_free_instance (((GTypeInstance *) self));
	}
}




