/* project-dialog-remove.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_PROJECT_DIALOG_REMOVE_H__
#define __SRC_PROJECT_DIALOG_REMOVE_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "src/project.h"

G_BEGIN_DECLS


#define VALIDE_TYPE_PROJECT_DIALOG_REMOVE (valide_project_dialog_remove_get_type ())
#define VALIDE_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemove))
#define VALIDE_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_PROJECT_DIALOG_REMOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))

typedef struct _ValideProjectDialogRemove ValideProjectDialogRemove;
typedef struct _ValideProjectDialogRemoveClass ValideProjectDialogRemoveClass;
typedef struct _ValideProjectDialogRemovePrivate ValideProjectDialogRemovePrivate;

struct _ValideProjectDialogRemove {
	GtkDialog parent_instance;
	ValideProjectDialogRemovePrivate * priv;
};

struct _ValideProjectDialogRemoveClass {
	GtkDialogClass parent_class;
};


ValideProjectDialogRemove* valide_project_dialog_remove_new (ValideProject* project);
void valide_project_dialog_remove_set_project (ValideProjectDialogRemove* self, ValideProject* value);
GList* valide_project_dialog_remove_get_selected_files (ValideProjectDialogRemove* self);
GType valide_project_dialog_remove_get_type (void);


G_END_DECLS

#endif
