/* project-dialog.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_PROJECT_DIALOG_H__
#define __SRC_PROJECT_DIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PROJECT_DIALOG (valide_project_dialog_get_type ())
#define VALIDE_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialog))
#define VALIDE_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialogClass))
#define VALIDE_IS_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG))
#define VALIDE_IS_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG))
#define VALIDE_PROJECT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialogClass))

typedef struct _ValideProjectDialog ValideProjectDialog;
typedef struct _ValideProjectDialogClass ValideProjectDialogClass;
typedef struct _ValideProjectDialogPrivate ValideProjectDialogPrivate;

struct _ValideProjectDialog {
	GtkDialog parent_instance;
	ValideProjectDialogPrivate * priv;
};

struct _ValideProjectDialogClass {
	GtkDialogClass parent_class;
};


ValideProjectDialog* valide_project_dialog_new (void);
const char* valide_project_dialog_get_project_name (ValideProjectDialog* self);
const char* valide_project_dialog_get_project_path (ValideProjectDialog* self);
const char* valide_project_dialog_get_project_dir (ValideProjectDialog* self);
const char* valide_project_dialog_get_template (ValideProjectDialog* self);
void valide_project_dialog_set_project_desc (ValideProjectDialog* self, const char* value);
GType valide_project_dialog_get_type (void);


G_END_DECLS

#endif
