/* project-manager.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_PROJECT_MANAGER_H__
#define __SRC_PROJECT_MANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "src/project.h"

G_BEGIN_DECLS


#define VALIDE_TYPE_PROJECT_MANAGER (valide_project_manager_get_type ())
#define VALIDE_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManager))
#define VALIDE_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManagerClass))
#define VALIDE_IS_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_MANAGER))
#define VALIDE_IS_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_MANAGER))
#define VALIDE_PROJECT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManagerClass))

typedef struct _ValideProjectManager ValideProjectManager;
typedef struct _ValideProjectManagerClass ValideProjectManagerClass;
typedef struct _ValideProjectManagerPrivate ValideProjectManagerPrivate;

typedef enum  {
	PROJECT_ERROR_MAX_OPEN
} ProjectError;
#define PROJECT_ERROR project_error_quark ()
struct _ValideProjectManager {
	GtkTreeView parent_instance;
	ValideProjectManagerPrivate * priv;
};

struct _ValideProjectManagerClass {
	GtkTreeViewClass parent_class;
};


GQuark project_error_quark (void);
void valide_project_manager_destroy (ValideProjectManager* self);
ValideProjectManager* valide_project_manager_get_instance (void);
void valide_project_manager_create (ValideProjectManager* self, const char* filename, GError** error);
void valide_project_manager_open (ValideProjectManager* self);
void valide_project_manager_close (ValideProjectManager* self, ValideProject* sender);
ValideProject* valide_project_manager_get_current (ValideProjectManager* self);
void valide_project_manager_set_current (ValideProjectManager* self, ValideProject* value);
GType valide_project_manager_get_type (void);


G_END_DECLS

#endif
