/* recent-manager-ui.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_RECENT_MANAGER_UI_H__
#define __SRC_RECENT_MANAGER_UI_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "src/uimanager.h"

G_BEGIN_DECLS


#define VALIDE_TYPE_RECENT_MANAGER_UI (valide_recent_manager_ui_get_type ())
#define VALIDE_RECENT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUI))
#define VALIDE_RECENT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIClass))
#define VALIDE_IS_RECENT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_RECENT_MANAGER_UI))
#define VALIDE_IS_RECENT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_RECENT_MANAGER_UI))
#define VALIDE_RECENT_MANAGER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIClass))

typedef struct _ValideRecentManagerUI ValideRecentManagerUI;
typedef struct _ValideRecentManagerUIClass ValideRecentManagerUIClass;
typedef struct _ValideRecentManagerUIPrivate ValideRecentManagerUIPrivate;

struct _ValideRecentManagerUI {
	GObject parent_instance;
	ValideRecentManagerUIPrivate * priv;
};

struct _ValideRecentManagerUIClass {
	GObjectClass parent_class;
};


ValideRecentManagerUI* valide_recent_manager_ui_get_instance (void);
void valide_recent_manager_ui_add_file (ValideRecentManagerUI* self, const char* uri);
void valide_recent_manager_ui_add_project (ValideRecentManagerUI* self, const char* uri);
void valide_recent_manager_ui_update_file (ValideRecentManagerUI* self, ValideUIManager* ui_manager);
void valide_recent_manager_ui_update_project (ValideRecentManagerUI* self, ValideUIManager* ui_manager);
GType valide_recent_manager_ui_get_type (void);


G_END_DECLS

#endif
