/* sourceview.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/sourceview.h>
#include <gtksourceview/gtksourcelanguagemanager.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gtk/gtk.h>




enum  {
	VALIDE_SOURCE_VIEW_DUMMY_PROPERTY
};
static GObject * valide_source_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer valide_source_view_parent_class = NULL;



#line 23 "sourceview.vala"
ValideSourceView* valide_source_view_new (void) {
	ValideSourceView * self;
	self = g_object_newv (VALIDE_TYPE_SOURCE_VIEW, 0, NULL);
	return self;
}


static GObject * valide_source_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideSourceViewClass * klass;
	GObjectClass * parent_class;
	ValideSourceView * self;
	klass = VALIDE_SOURCE_VIEW_CLASS (g_type_class_peek (VALIDE_TYPE_SOURCE_VIEW));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_SOURCE_VIEW (obj);
	{
		GtkSourceLanguageManager* lm;
		GtkSourceBuffer* buffer;
		PangoFontDescription* desc;
		lm = gtk_source_language_manager_new ();
		buffer = gtk_source_buffer_new_with_language (gtk_source_language_manager_get_language (lm, "vala"));
#line 29 "sourceview.vala"
		gtk_source_buffer_set_highlight_syntax (buffer, TRUE);
		desc = pango_font_description_new ();
#line 32 "sourceview.vala"
		pango_font_description_set_family (desc, "Monospace");
#line 33 "sourceview.vala"
		gtk_widget_modify_font (GTK_WIDGET (self), desc);
#line 35 "sourceview.vala"
		gtk_source_view_set_right_margin_position (GTK_SOURCE_VIEW (self), ((guint) 80));
#line 36 "sourceview.vala"
		gtk_source_view_set_show_right_margin (GTK_SOURCE_VIEW (self), TRUE);
#line 37 "sourceview.vala"
		gtk_source_view_set_auto_indent (GTK_SOURCE_VIEW (self), TRUE);
#line 38 "sourceview.vala"
		gtk_source_view_set_highlight_current_line (GTK_SOURCE_VIEW (self), TRUE);
#line 39 "sourceview.vala"
		gtk_source_view_set_indent_width (GTK_SOURCE_VIEW (self), 2);
#line 40 "sourceview.vala"
		gtk_source_view_set_indent_on_tab (GTK_SOURCE_VIEW (self), TRUE);
#line 41 "sourceview.vala"
		gtk_source_view_set_insert_spaces_instead_of_tabs (GTK_SOURCE_VIEW (self), TRUE);
#line 42 "sourceview.vala"
		gtk_source_view_set_smart_home_end (GTK_SOURCE_VIEW (self), GTK_SOURCE_SMART_HOME_END_BEFORE);
#line 43 "sourceview.vala"
		gtk_source_view_set_tab_width (GTK_SOURCE_VIEW (self), ((guint) 2));
#line 45 "sourceview.vala"
		gtk_text_view_set_buffer (GTK_TEXT_VIEW (self), GTK_TEXT_BUFFER (buffer));
		(lm == NULL ? NULL : (lm = (g_object_unref (lm), NULL)));
		(buffer == NULL ? NULL : (buffer = (g_object_unref (buffer), NULL)));
		(desc == NULL ? NULL : (desc = (pango_font_description_free (desc), NULL)));
	}
	return obj;
}


static void valide_source_view_class_init (ValideSourceViewClass * klass) {
	valide_source_view_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = valide_source_view_constructor;
}


static void valide_source_view_init (ValideSourceView * self) {
}


GType valide_source_view_get_type (void) {
	static GType valide_source_view_type_id = 0;
	if (G_UNLIKELY (valide_source_view_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideSourceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_source_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideSourceView), 0, (GInstanceInitFunc) valide_source_view_init };
		valide_source_view_type_id = g_type_register_static (GTK_TYPE_SOURCE_VIEW, "ValideSourceView", &g_define_type_info, 0);
	}
	return valide_source_view_type_id;
}




