/* sourceview.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.SourceView : Gtk.SourceView
{
  construct
  {
    Gtk.SourceLanguageManager lm = new Gtk.SourceLanguageManager ();
    Gtk.SourceBuffer buffer = new Gtk.SourceBuffer.with_language (lm.get_language ("vala"));
    buffer.set_highlight_syntax (true);

    Pango.FontDescription desc =  new Pango.FontDescription ();
    desc.set_family ("Monospace");
    this.modify_font (desc);

    this.set_right_margin_position (80);
    this.set_show_right_margin (true);
    this.set_auto_indent (true);
    this.set_highlight_current_line (true);
    this.set_indent_width (2);
    this.set_indent_on_tab (true);
    this.set_insert_spaces_instead_of_tabs (true);
    this.set_smart_home_end (Gtk.SourceSmartHomeEndType.BEFORE);
    this.set_tab_width (2);

    this.buffer = buffer;
  }
}

