/* splashscreen.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/splashscreen.h>
#include <config.h>
#include <stdlib.h>
#include <string.h>
#include "src/window.h"




enum  {
	VALIDE_SPLASH_SCREEN_DUMMY_PROPERTY
};
static ValideSplashScreen* valide_splash_screen_instance = NULL;
static ValideSplashScreen* valide_splash_screen_new (void);
static GObject * valide_splash_screen_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer valide_splash_screen_parent_class = NULL;
static void valide_splash_screen_dispose (GObject * obj);



#line 37 "splashscreen.vala"
static ValideSplashScreen* valide_splash_screen_new (void) {
	ValideSplashScreen * self;
	self = g_object_newv (VALIDE_TYPE_SPLASH_SCREEN, 0, NULL);
	return self;
}


#line 41 "splashscreen.vala"
ValideSplashScreen* valide_splash_screen_get_instance (void) {
	ValideSplashScreen* _tmp1;
#line 43 "splashscreen.vala"
	if (valide_splash_screen_instance == NULL) {
		ValideSplashScreen* _tmp0;
		_tmp0 = NULL;
#line 45 "splashscreen.vala"
		valide_splash_screen_instance = (_tmp0 = g_object_ref_sink (valide_splash_screen_new ()), (valide_splash_screen_instance == NULL ? NULL : (valide_splash_screen_instance = (g_object_unref (valide_splash_screen_instance), NULL))), _tmp0);
	}
#line 47 "splashscreen.vala"
	_tmp1 = NULL;
#line 47 "splashscreen.vala"
	return (_tmp1 = valide_splash_screen_instance, (_tmp1 == NULL ? NULL : g_object_ref (_tmp1)));
}


#line 50 "splashscreen.vala"
gboolean valide_splash_screen_run (ValideSplashScreen* self) {
	ValideWindow* window;
	gboolean _tmp0;
#line 50 "splashscreen.vala"
	g_return_val_if_fail (VALIDE_IS_SPLASH_SCREEN (self), FALSE);
#line 52 "splashscreen.vala"
	gtk_widget_show_all (GTK_WIDGET (self));
#line 53 "splashscreen.vala"
	while (gtk_events_pending ()) {
#line 55 "splashscreen.vala"
		gtk_main_iteration ();
	}
	window = valide_window_get_instance ();
#line 58 "splashscreen.vala"
	valide_window_run (window);
#line 59 "splashscreen.vala"
	gtk_object_destroy (GTK_OBJECT (self));
#line 60 "splashscreen.vala"
	return (_tmp0 = FALSE, (window == NULL ? NULL : (window = (g_object_unref (window), NULL))), _tmp0);
}


static GObject * valide_splash_screen_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideSplashScreenClass * klass;
	GObjectClass * parent_class;
	ValideSplashScreen * self;
	klass = VALIDE_SPLASH_SCREEN_CLASS (g_type_class_peek (VALIDE_TYPE_SPLASH_SCREEN));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_SPLASH_SCREEN (obj);
	{
		GtkWindowType _tmp0;
		GtkVBox* vbox;
		char* _tmp1;
		GtkImage* _tmp2;
		GtkImage* image;
#line 29 "splashscreen.vala"
		g_object_set (GTK_WINDOW (self), "type", GTK_WINDOW_POPUP, NULL);
#line 30 "splashscreen.vala"
		gtk_window_set_position (GTK_WINDOW (self), GTK_WIN_POS_CENTER);
		vbox = g_object_ref_sink (gtk_vbox_new (FALSE, 0));
#line 32 "splashscreen.vala"
		gtk_container_add (GTK_CONTAINER (self), GTK_WIDGET (vbox));
#line 33 "splashscreen.vala"
		_tmp1 = NULL;
#line 33 "splashscreen.vala"
		_tmp2 = NULL;
		image = (_tmp2 = g_object_ref_sink (gtk_image_new_from_file ((_tmp1 = g_build_filename (PACKAGE_PIXMAPS_DIR, "logo.png", NULL)))), (_tmp1 = (g_free (_tmp1), NULL)), _tmp2);
#line 34 "splashscreen.vala"
		gtk_box_pack_start (GTK_BOX (vbox), GTK_WIDGET (image), TRUE, TRUE, ((guint) 0));
		(vbox == NULL ? NULL : (vbox = (g_object_unref (vbox), NULL)));
		(image == NULL ? NULL : (image = (g_object_unref (image), NULL)));
	}
	return obj;
}


static void valide_splash_screen_class_init (ValideSplashScreenClass * klass) {
	valide_splash_screen_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = valide_splash_screen_constructor;
	G_OBJECT_CLASS (klass)->dispose = valide_splash_screen_dispose;
}


static void valide_splash_screen_init (ValideSplashScreen * self) {
}


static void valide_splash_screen_dispose (GObject * obj) {
	ValideSplashScreen * self;
	self = VALIDE_SPLASH_SCREEN (obj);
	G_OBJECT_CLASS (valide_splash_screen_parent_class)->dispose (obj);
}


GType valide_splash_screen_get_type (void) {
	static GType valide_splash_screen_type_id = 0;
	if (G_UNLIKELY (valide_splash_screen_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideSplashScreenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_splash_screen_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideSplashScreen), 0, (GInstanceInitFunc) valide_splash_screen_init };
		valide_splash_screen_type_id = g_type_register_static (GTK_TYPE_WINDOW, "ValideSplashScreen", &g_define_type_info, 0);
	}
	return valide_splash_screen_type_id;
}




