/* splashscreen.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_SPLASHSCREEN_H__
#define __SRC_SPLASHSCREEN_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_SPLASH_SCREEN (valide_splash_screen_get_type ())
#define VALIDE_SPLASH_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SPLASH_SCREEN, ValideSplashScreen))
#define VALIDE_SPLASH_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SPLASH_SCREEN, ValideSplashScreenClass))
#define VALIDE_IS_SPLASH_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SPLASH_SCREEN))
#define VALIDE_IS_SPLASH_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SPLASH_SCREEN))
#define VALIDE_SPLASH_SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SPLASH_SCREEN, ValideSplashScreenClass))

typedef struct _ValideSplashScreen ValideSplashScreen;
typedef struct _ValideSplashScreenClass ValideSplashScreenClass;
typedef struct _ValideSplashScreenPrivate ValideSplashScreenPrivate;

struct _ValideSplashScreen {
	GtkWindow parent_instance;
	ValideSplashScreenPrivate * priv;
};

struct _ValideSplashScreenClass {
	GtkWindowClass parent_class;
};


ValideSplashScreen* valide_splash_screen_get_instance (void);
gboolean valide_splash_screen_run (ValideSplashScreen* self);
GType valide_splash_screen_get_type (void);


G_END_DECLS

#endif
