/* splashscreen.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.SplashScreen : Gtk.Window
{
  private static SplashScreen instance = null;

  construct
  {
    this.type = Gtk.WindowType.POPUP;
    this.set_position (Gtk.WindowPosition.CENTER);
    Gtk.VBox vbox = new Gtk.VBox (false, 0);
    this.add (vbox);
    Gtk.Image image = new Gtk.Image.from_file (GLib.Path.build_filename (Config.PACKAGE_PIXMAPS_DIR, "logo.png"));
    vbox.pack_start (image, true, true, 0);
  }

  private SplashScreen ()
  {
  }

  public static SplashScreen get_instance ()
  {
    if (SplashScreen.instance == null)
    {
      SplashScreen.instance = new SplashScreen ();
    }
    return SplashScreen.instance;
  }

  public bool run ()
  {
    this.show_all ();
    while (Gtk.events_pending ())
    {
      Gtk.main_iteration ();
    }
    Window window = Window.get_instance ();
    window.run ();
    this.destroy ();
    return false;
  }
}

