/* template-manager.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/template-manager.h>
#include <config.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>




enum  {
	VALIDE_TEMPLATE_MANAGER_DUMMY_PROPERTY
};
static ValideTemplateManager* valide_template_manager_instance = NULL;
static char* valide_template_manager_get_path (ValideTemplateManager* self, const char* name);
static ValideTemplateManager* valide_template_manager_new (void);
static void _g_list_free_g_free (GList* self);
static gpointer valide_template_manager_parent_class = NULL;
static void valide_template_manager_dispose (GObject * obj);



#line 29 "template-manager.vala"
static char* valide_template_manager_get_path (ValideTemplateManager* self, const char* name) {
#line 29 "template-manager.vala"
	g_return_val_if_fail (VALIDE_IS_TEMPLATE_MANAGER (self), NULL);
#line 29 "template-manager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 31 "template-manager.vala"
	return g_build_filename (VALIDE_TEMPLATE_MANAGER_directory, name, "template.xml", NULL);
}


#line 35 "template-manager.vala"
static ValideTemplateManager* valide_template_manager_new (void) {
	ValideTemplateManager * self;
	self = g_object_newv (VALIDE_TYPE_TEMPLATE_MANAGER, 0, NULL);
	return self;
}


#line 39 "template-manager.vala"
ValideTemplateManager* valide_template_manager_get_instance (void) {
	ValideTemplateManager* _tmp1;
#line 41 "template-manager.vala"
	if (valide_template_manager_instance == NULL) {
		ValideTemplateManager* _tmp0;
		_tmp0 = NULL;
#line 43 "template-manager.vala"
		valide_template_manager_instance = (_tmp0 = valide_template_manager_new (), (valide_template_manager_instance == NULL ? NULL : (valide_template_manager_instance = (g_object_unref (valide_template_manager_instance), NULL))), _tmp0);
	}
#line 45 "template-manager.vala"
	_tmp1 = NULL;
#line 45 "template-manager.vala"
	return (_tmp1 = valide_template_manager_instance, (_tmp1 == NULL ? NULL : g_object_ref (_tmp1)));
}


static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, ((GFunc) g_free), NULL);
	g_list_free (self);
}


#line 48 "template-manager.vala"
GList* valide_template_manager_get_list (ValideTemplateManager* self) {
	GError * inner_error;
	GList* list;
#line 48 "template-manager.vala"
	g_return_val_if_fail (VALIDE_IS_TEMPLATE_MANAGER (self), NULL);
	inner_error = NULL;
	list = NULL;
	{
		GDir* dir;
		dir = g_dir_open (VALIDE_TEMPLATE_MANAGER_directory, 0, &inner_error);
		if (inner_error != NULL) {
			goto __catch9_g_error;
		}
#line 56 "template-manager.vala"
		do {
			const char* _tmp0;
			char* filename;
#line 58 "template-manager.vala"
			_tmp0 = NULL;
			filename = (_tmp0 = g_dir_read_name (dir), (_tmp0 == NULL ? NULL : g_strdup (_tmp0)));
#line 59 "template-manager.vala"
			if (filename != NULL) {
				char* file;
				file = valide_template_manager_get_path (self, filename);
#line 62 "template-manager.vala"
				if (g_file_test (file, G_FILE_TEST_EXISTS)) {
					const char* _tmp1;
#line 64 "template-manager.vala"
					_tmp1 = NULL;
#line 64 "template-manager.vala"
					list = g_list_append (list, (_tmp1 = file, (_tmp1 == NULL ? NULL : g_strdup (_tmp1))));
				}
				file = (g_free (file), NULL);
			} else {
				filename = (g_free (filename), NULL);
#line 69 "template-manager.vala"
				break;
			}
			filename = (g_free (filename), NULL);
		} while (TRUE);
#line 72 "template-manager.vala"
		g_list_first (list);
		(dir == NULL ? NULL : (dir = (g_dir_close (dir), NULL)));
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError * e;
		e = inner_error;
		inner_error = NULL;
		{
#line 76 "template-manager.vala"
			g_critical (e->message);
		}
	}
	__finally9:
	;
#line 78 "template-manager.vala"
	return list;
}


static void valide_template_manager_class_init (ValideTemplateManagerClass * klass) {
	valide_template_manager_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->dispose = valide_template_manager_dispose;
}


static void valide_template_manager_init (ValideTemplateManager * self) {
}


static void valide_template_manager_dispose (GObject * obj) {
	ValideTemplateManager * self;
	self = VALIDE_TEMPLATE_MANAGER (obj);
	G_OBJECT_CLASS (valide_template_manager_parent_class)->dispose (obj);
}


GType valide_template_manager_get_type (void) {
	static GType valide_template_manager_type_id = 0;
	if (G_UNLIKELY (valide_template_manager_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideTemplateManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_template_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideTemplateManager), 0, (GInstanceInitFunc) valide_template_manager_init };
		valide_template_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ValideTemplateManager", &g_define_type_info, 0);
	}
	return valide_template_manager_type_id;
}




