/* template.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_TEMPLATE_H__
#define __SRC_TEMPLATE_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_TEMPLATE (valide_template_get_type ())
#define VALIDE_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_TEMPLATE, ValideTemplate))
#define VALIDE_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_TEMPLATE, ValideTemplateClass))
#define VALIDE_IS_TEMPLATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_TEMPLATE))
#define VALIDE_IS_TEMPLATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_TEMPLATE))
#define VALIDE_TEMPLATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_TEMPLATE, ValideTemplateClass))

typedef struct _ValideTemplate ValideTemplate;
typedef struct _ValideTemplateClass ValideTemplateClass;
typedef struct _ValideTemplatePrivate ValideTemplatePrivate;

struct _ValideTemplate {
	GObject parent_instance;
	ValideTemplatePrivate * priv;
};

struct _ValideTemplateClass {
	GObjectClass parent_class;
};


ValideTemplate* valide_template_new (const char* filename);
char* valide_template_get_filename (ValideTemplate* self);
void valide_template_set_filename (ValideTemplate* self, char* value);
GdkPixbuf* valide_template_get_icon (ValideTemplate* self);
const char* valide_template_get_name (ValideTemplate* self);
const char* valide_template_get_desc (ValideTemplate* self);
GList* valide_template_get_files (ValideTemplate* self);
const char* valide_template_get_path (ValideTemplate* self);
GType valide_template_get_type (void);


G_END_DECLS

#endif
