/* executable-manager.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_THIRD_PARTY_EXECUTABLE_MANAGER_H__
#define __SRC_THIRD_PARTY_EXECUTABLE_MANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_EXECUTABLE_MANAGER (valide_executable_manager_get_type ())
#define VALIDE_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManager))
#define VALIDE_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))
#define VALIDE_IS_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_IS_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_EXECUTABLE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))

typedef struct _ValideExecutableManager ValideExecutableManager;
typedef struct _ValideExecutableManagerClass ValideExecutableManagerClass;
typedef struct _ValideExecutableManagerPrivate ValideExecutableManagerPrivate;

struct _ValideExecutableManager {
	GtkHBox parent_instance;
	ValideExecutableManagerPrivate * priv;
};

struct _ValideExecutableManagerClass {
	GtkHBoxClass parent_class;
};


ValideExecutableManager* valide_executable_manager_get_instance (void);
void valide_executable_manager_run (ValideExecutableManager* self, const char* dir, const char* cmd);
void valide_executable_manager_add_line (ValideExecutableManager* self, const char* line);
GType valide_executable_manager_get_type (void);


G_END_DECLS

#endif
