/* panel.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __SRC_THIRD_PARTY_PANEL_H__
#define __SRC_THIRD_PARTY_PANEL_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PANEL (valide_panel_get_type ())
#define VALIDE_PANEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PANEL, ValidePanel))
#define VALIDE_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PANEL, ValidePanelClass))
#define VALIDE_IS_PANEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PANEL))
#define VALIDE_IS_PANEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PANEL))
#define VALIDE_PANEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PANEL, ValidePanelClass))

typedef struct _ValidePanel ValidePanel;
typedef struct _ValidePanelClass ValidePanelClass;
typedef struct _ValidePanelPrivate ValidePanelPrivate;

struct _ValidePanel {
	GtkVBox parent_instance;
	ValidePanelPrivate * priv;
};

struct _ValidePanelClass {
	GtkVBoxClass parent_class;
};


ValidePanel* valide_panel_new (GtkOrientation orientation);
void valide_panel_add_item (ValidePanel* self, GtkWidget* item, const char* name, GtkImage* image);
void valide_panel_add_item_with_stock_icon (ValidePanel* self, GtkWidget* item, const char* name, const char* stock_id);
GtkOrientation valide_panel_get_orientation (ValidePanel* self);
void valide_panel_set_orientation (ValidePanel* self, GtkOrientation value);
GType valide_panel_get_type (void);


G_END_DECLS

#endif
