/* uimanager.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#include <src/uimanager.h>
#include <glib/gi18n-lib.h>




struct _ValideUIManagerPrivate {
	GtkActionGroup* action_group;
	GtkActionGroup* document_action_group;
};

#define VALIDE_UI_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_UI_MANAGER, ValideUIManagerPrivate))
enum  {
	VALIDE_UI_MANAGER_DUMMY_PROPERTY
};
static ValideUIManager* valide_ui_manager_instance;
static ValideUIManager* valide_ui_manager_new (void);
static GObject * valide_ui_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer valide_ui_manager_parent_class = NULL;
static void valide_ui_manager_dispose (GObject * obj);



#line 86 "uimanager.vala"
static ValideUIManager* valide_ui_manager_new (void) {
	ValideUIManager * self;
	self = g_object_newv (VALIDE_TYPE_UI_MANAGER, 0, NULL);
	return self;
}


#line 90 "uimanager.vala"
ValideUIManager* valide_ui_manager_get_instance (void) {
	ValideUIManager* _tmp1;
#line 92 "uimanager.vala"
	if (valide_ui_manager_instance == NULL) {
		ValideUIManager* _tmp0;
		_tmp0 = NULL;
#line 94 "uimanager.vala"
		valide_ui_manager_instance = (_tmp0 = valide_ui_manager_new (), (valide_ui_manager_instance == NULL ? NULL : (valide_ui_manager_instance = (g_object_unref (valide_ui_manager_instance), NULL))), _tmp0);
	}
#line 96 "uimanager.vala"
	_tmp1 = NULL;
#line 96 "uimanager.vala"
	return (_tmp1 = valide_ui_manager_instance, (_tmp1 == NULL ? NULL : g_object_ref (_tmp1)));
}


#line 99 "uimanager.vala"
GtkAction* valide_ui_manager_get_action (ValideUIManager* self, const char* name) {
	GtkAction* _tmp0;
#line 99 "uimanager.vala"
	g_return_val_if_fail (VALIDE_IS_UI_MANAGER (self), NULL);
#line 99 "uimanager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 101 "uimanager.vala"
	_tmp0 = NULL;
#line 101 "uimanager.vala"
	return (_tmp0 = gtk_action_group_get_action (self->priv->action_group, name), (_tmp0 == NULL ? NULL : g_object_ref (_tmp0)));
}


static GObject * valide_ui_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideUIManagerClass * klass;
	GObjectClass * parent_class;
	ValideUIManager * self;
	klass = VALIDE_UI_MANAGER_CLASS (g_type_class_peek (VALIDE_TYPE_UI_MANAGER));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_UI_MANAGER (obj);
	{
		GtkToggleAction* ta;
		GtkActionGroup* _tmp0;
		GtkActionGroup* _tmp1;
		GtkAction* _tmp2;
		GtkAction* _tmp3;
		GtkAction* _tmp4;
		GtkAction* _tmp5;
		GtkAction* _tmp6;
		GtkAction* _tmp7;
		GtkAction* _tmp8;
		GtkAction* _tmp9;
		GtkAction* _tmp10;
		GtkAction* _tmp11;
		GtkAction* _tmp12;
		GtkAction* _tmp13;
		GtkAction* _tmp14;
		GtkAction* _tmp15;
		GtkAction* _tmp16;
		GtkToggleAction* _tmp17;
		GtkToggleAction* _tmp18;
		GtkAction* _tmp19;
		GtkAction* _tmp20;
		GtkAction* _tmp21;
		GtkAction* _tmp22;
		GtkAction* _tmp23;
		GtkAction* _tmp24;
		GtkAction* _tmp25;
		GtkAction* _tmp26;
		GtkAction* _tmp27;
		GtkAction* _tmp28;
		GtkAction* _tmp29;
		GtkAction* _tmp30;
		GtkAction* _tmp31;
		GtkAction* _tmp32;
		GtkAction* _tmp33;
		ta = NULL;
		_tmp0 = NULL;
#line 35 "uimanager.vala"
		self->priv->action_group = (_tmp0 = gtk_action_group_new ("general"), (self->priv->action_group == NULL ? NULL : (self->priv->action_group = (g_object_unref (self->priv->action_group), NULL))), _tmp0);
		_tmp1 = NULL;
#line 36 "uimanager.vala"
		self->priv->document_action_group = (_tmp1 = gtk_action_group_new ("document"), (self->priv->document_action_group == NULL ? NULL : (self->priv->document_action_group = (g_object_unref (self->priv->document_action_group), NULL))), _tmp1);
		/* File menu */
#line 39 "uimanager.vala"
		_tmp2 = NULL;
#line 39 "uimanager.vala"
		gtk_action_group_add_action (self->priv->action_group, (_tmp2 = gtk_action_new ("file", _ ("_File"), NULL, NULL)));
		(_tmp2 == NULL ? NULL : (_tmp2 = (g_object_unref (_tmp2), NULL)));
#line 40 "uimanager.vala"
		_tmp3 = NULL;
#line 40 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp3 = gtk_action_new ("file-new", NULL, _ ("Create new source file"), GTK_STOCK_NEW)), NULL);
		(_tmp3 == NULL ? NULL : (_tmp3 = (g_object_unref (_tmp3), NULL)));
#line 41 "uimanager.vala"
		_tmp4 = NULL;
#line 41 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp4 = gtk_action_new ("file-open", NULL, _ ("Open source file"), GTK_STOCK_OPEN)), NULL);
		(_tmp4 == NULL ? NULL : (_tmp4 = (g_object_unref (_tmp4), NULL)));
#line 42 "uimanager.vala"
		_tmp5 = NULL;
#line 42 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp5 = gtk_action_new ("file-save", NULL, _ ("Save source file"), GTK_STOCK_SAVE)), NULL);
		(_tmp5 == NULL ? NULL : (_tmp5 = (g_object_unref (_tmp5), NULL)));
#line 43 "uimanager.vala"
		_tmp6 = NULL;
#line 43 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp6 = gtk_action_new ("file-save-as", NULL, _ ("Save as source file"), GTK_STOCK_SAVE_AS)), NULL);
		(_tmp6 == NULL ? NULL : (_tmp6 = (g_object_unref (_tmp6), NULL)));
#line 44 "uimanager.vala"
		_tmp7 = NULL;
#line 44 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp7 = gtk_action_new ("file-close", NULL, _ ("Close source file"), GTK_STOCK_CLOSE)), NULL);
		(_tmp7 == NULL ? NULL : (_tmp7 = (g_object_unref (_tmp7), NULL)));
#line 45 "uimanager.vala"
		_tmp8 = NULL;
#line 45 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp8 = gtk_action_new ("file-close-all", _ ("C_lose all"), _ ("Close all sources files"), NULL)), NULL);
		(_tmp8 == NULL ? NULL : (_tmp8 = (g_object_unref (_tmp8), NULL)));
#line 46 "uimanager.vala"
		_tmp9 = NULL;
#line 46 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp9 = gtk_action_new ("quit", NULL, _ ("Quit application"), GTK_STOCK_QUIT)), NULL);
		(_tmp9 == NULL ? NULL : (_tmp9 = (g_object_unref (_tmp9), NULL)));
		/* Edit menu */
#line 49 "uimanager.vala"
		_tmp10 = NULL;
#line 49 "uimanager.vala"
		gtk_action_group_add_action (self->priv->action_group, (_tmp10 = gtk_action_new ("edit", _ ("_Edit"), NULL, NULL)));
		(_tmp10 == NULL ? NULL : (_tmp10 = (g_object_unref (_tmp10), NULL)));
#line 50 "uimanager.vala"
		_tmp11 = NULL;
#line 50 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp11 = gtk_action_new ("edit-undo", NULL, _ ("Undo last action"), GTK_STOCK_UNDO)), "<ctrl>Z");
		(_tmp11 == NULL ? NULL : (_tmp11 = (g_object_unref (_tmp11), NULL)));
#line 51 "uimanager.vala"
		_tmp12 = NULL;
#line 51 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp12 = gtk_action_new ("edit-redo", NULL, _ ("Redo last undo action"), GTK_STOCK_REDO)), "<ctrl><shift>Z");
		(_tmp12 == NULL ? NULL : (_tmp12 = (g_object_unref (_tmp12), NULL)));
#line 52 "uimanager.vala"
		_tmp13 = NULL;
#line 52 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp13 = gtk_action_new ("edit-copy", NULL, _ ("Copy text"), GTK_STOCK_COPY)), NULL);
		(_tmp13 == NULL ? NULL : (_tmp13 = (g_object_unref (_tmp13), NULL)));
#line 53 "uimanager.vala"
		_tmp14 = NULL;
#line 53 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp14 = gtk_action_new ("edit-cut", NULL, _ ("Cut text"), GTK_STOCK_CUT)), NULL);
		(_tmp14 == NULL ? NULL : (_tmp14 = (g_object_unref (_tmp14), NULL)));
#line 54 "uimanager.vala"
		_tmp15 = NULL;
#line 54 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp15 = gtk_action_new ("edit-paste", NULL, _ ("Paste text"), GTK_STOCK_PASTE)), NULL);
		(_tmp15 == NULL ? NULL : (_tmp15 = (g_object_unref (_tmp15), NULL)));
		/* View menu */
#line 57 "uimanager.vala"
		_tmp16 = NULL;
#line 57 "uimanager.vala"
		gtk_action_group_add_action (self->priv->action_group, (_tmp16 = gtk_action_new ("view", _ ("_View"), NULL, NULL)));
		(_tmp16 == NULL ? NULL : (_tmp16 = (g_object_unref (_tmp16), NULL)));
#line 58 "uimanager.vala"
		_tmp17 = NULL;
#line 58 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, GTK_ACTION ((_tmp17 = gtk_toggle_action_new ("view-side-panel", _ ("Side panel"), _ ("Side panel"), NULL))), "F9");
		(_tmp17 == NULL ? NULL : (_tmp17 = (g_object_unref (_tmp17), NULL)));
#line 59 "uimanager.vala"
		_tmp18 = NULL;
#line 59 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, GTK_ACTION ((_tmp18 = gtk_toggle_action_new ("view-bottom-panel", _ ("Bottom panel"), _ ("Bottom panel"), NULL))), "<ctrl>F9");
		(_tmp18 == NULL ? NULL : (_tmp18 = (g_object_unref (_tmp18), NULL)));
		/* Project menu */
#line 62 "uimanager.vala"
		_tmp19 = NULL;
#line 62 "uimanager.vala"
		gtk_action_group_add_action (self->priv->action_group, (_tmp19 = gtk_action_new ("project", _ ("_Project"), NULL, NULL)));
		(_tmp19 == NULL ? NULL : (_tmp19 = (g_object_unref (_tmp19), NULL)));
#line 63 "uimanager.vala"
		_tmp20 = NULL;
#line 63 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp20 = gtk_action_new ("project-new", NULL, _ ("Create new project"), GTK_STOCK_NEW)), "<ctrl><shift>N");
		(_tmp20 == NULL ? NULL : (_tmp20 = (g_object_unref (_tmp20), NULL)));
#line 64 "uimanager.vala"
		_tmp21 = NULL;
#line 64 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp21 = gtk_action_new ("project-open", NULL, _ ("Open project"), GTK_STOCK_OPEN)), "<ctrl><shift>O");
		(_tmp21 == NULL ? NULL : (_tmp21 = (g_object_unref (_tmp21), NULL)));
#line 65 "uimanager.vala"
		_tmp22 = NULL;
#line 65 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp22 = gtk_action_new ("project-add", _ ("_Add file"), _ ("Add file to project"), GTK_STOCK_ADD)), NULL);
		(_tmp22 == NULL ? NULL : (_tmp22 = (g_object_unref (_tmp22), NULL)));
#line 66 "uimanager.vala"
		_tmp23 = NULL;
#line 66 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp23 = gtk_action_new ("project-remove", _ ("_Remove file"), _ ("Remove file to project"), GTK_STOCK_REMOVE)), NULL);
		(_tmp23 == NULL ? NULL : (_tmp23 = (g_object_unref (_tmp23), NULL)));
#line 67 "uimanager.vala"
		_tmp24 = NULL;
#line 67 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp24 = gtk_action_new ("project-options", _ ("O_ptions"), _ ("Project options"), GTK_STOCK_PROPERTIES)), NULL);
		(_tmp24 == NULL ? NULL : (_tmp24 = (g_object_unref (_tmp24), NULL)));
#line 68 "uimanager.vala"
		_tmp25 = NULL;
#line 68 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp25 = gtk_action_new ("project-compile", _ ("_Compile"), _ ("Compile project"), GTK_STOCK_CONVERT)), "F11");
		(_tmp25 == NULL ? NULL : (_tmp25 = (g_object_unref (_tmp25), NULL)));
#line 69 "uimanager.vala"
		_tmp26 = NULL;
#line 69 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp26 = gtk_action_new ("project-execute", NULL, _ ("Execute project"), GTK_STOCK_EXECUTE)), "F12");
		(_tmp26 == NULL ? NULL : (_tmp26 = (g_object_unref (_tmp26), NULL)));
#line 70 "uimanager.vala"
		_tmp27 = NULL;
#line 70 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp27 = gtk_action_new ("project-close", NULL, _ ("Close project"), GTK_STOCK_CLOSE)), "<ctrl><shift>W");
		(_tmp27 == NULL ? NULL : (_tmp27 = (g_object_unref (_tmp27), NULL)));
		/* Help menu */
#line 73 "uimanager.vala"
		_tmp28 = NULL;
#line 73 "uimanager.vala"
		gtk_action_group_add_action (self->priv->action_group, (_tmp28 = gtk_action_new ("help", _ ("_Help"), NULL, NULL)));
		(_tmp28 == NULL ? NULL : (_tmp28 = (g_object_unref (_tmp28), NULL)));
#line 74 "uimanager.vala"
		_tmp29 = NULL;
#line 74 "uimanager.vala"
		gtk_action_group_add_action (self->priv->action_group, (_tmp29 = gtk_action_new ("help-about", NULL, _ ("About this application"), GTK_STOCK_ABOUT)));
		(_tmp29 == NULL ? NULL : (_tmp29 = (g_object_unref (_tmp29), NULL)));
		/* Project popup */
#line 77 "uimanager.vala"
		_tmp30 = NULL;
#line 77 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp30 = gtk_action_new ("project-file-new", _ ("New file"), _ ("Create new source file"), GTK_STOCK_NEW)), NULL);
		(_tmp30 == NULL ? NULL : (_tmp30 = (g_object_unref (_tmp30), NULL)));
#line 78 "uimanager.vala"
		_tmp31 = NULL;
#line 78 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp31 = gtk_action_new ("project-file-open", _ ("Open file"), _ ("Open source file"), GTK_STOCK_OPEN)), NULL);
		(_tmp31 == NULL ? NULL : (_tmp31 = (g_object_unref (_tmp31), NULL)));
#line 79 "uimanager.vala"
		_tmp32 = NULL;
#line 79 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp32 = gtk_action_new ("project-file-add", _ ("Add file"), _ ("Add source file to project"), GTK_STOCK_ADD)), NULL);
		(_tmp32 == NULL ? NULL : (_tmp32 = (g_object_unref (_tmp32), NULL)));
#line 80 "uimanager.vala"
		_tmp33 = NULL;
#line 80 "uimanager.vala"
		gtk_action_group_add_action_with_accel (self->priv->action_group, (_tmp33 = gtk_action_new ("project-file-remove", _ ("Remove file"), _ ("Remove this file to project"), GTK_STOCK_REMOVE)), NULL);
		(_tmp33 == NULL ? NULL : (_tmp33 = (g_object_unref (_tmp33), NULL)));
#line 82 "uimanager.vala"
		gtk_ui_manager_insert_action_group (GTK_UI_MANAGER (self), self->priv->action_group, 0);
#line 83 "uimanager.vala"
		gtk_ui_manager_insert_action_group (GTK_UI_MANAGER (self), self->priv->document_action_group, 0);
		(ta == NULL ? NULL : (ta = (g_object_unref (ta), NULL)));
	}
	return obj;
}


static void valide_ui_manager_class_init (ValideUIManagerClass * klass) {
	valide_ui_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideUIManagerPrivate));
	G_OBJECT_CLASS (klass)->constructor = valide_ui_manager_constructor;
	G_OBJECT_CLASS (klass)->dispose = valide_ui_manager_dispose;
}


static void valide_ui_manager_init (ValideUIManager * self) {
	self->priv = VALIDE_UI_MANAGER_GET_PRIVATE (self);
}


static void valide_ui_manager_dispose (GObject * obj) {
	ValideUIManager * self;
	self = VALIDE_UI_MANAGER (obj);
	(self->priv->action_group == NULL ? NULL : (self->priv->action_group = (g_object_unref (self->priv->action_group), NULL)));
	(self->priv->document_action_group == NULL ? NULL : (self->priv->document_action_group = (g_object_unref (self->priv->document_action_group), NULL)));
	G_OBJECT_CLASS (valide_ui_manager_parent_class)->dispose (obj);
}


GType valide_ui_manager_get_type (void) {
	static GType valide_ui_manager_type_id = 0;
	if (G_UNLIKELY (valide_ui_manager_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideUIManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_ui_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideUIManager), 0, (GInstanceInitFunc) valide_ui_manager_init };
		valide_ui_manager_type_id = g_type_register_static (GTK_TYPE_UI_MANAGER, "ValideUIManager", &g_define_type_info, 0);
	}
	return valide_ui_manager_type_id;
}




